Package: spkTools
Version: 1.67.0
Date: 2016-02-10
Title: Methods for Spike-in Arrays
Author: Matthew N McCall <mccallm@gmail.com>, Rafael A Irizarry
        <rafa@jhu.edu>
Maintainer: Matthew N McCall <mccallm@gmail.com>
Depends: R (>= 2.7.0), Biobase (>= 2.5.5)
Suggests: xtable
Imports: Biobase (>= 2.5.5), graphics, grDevices, gtools, methods,
        RColorBrewer, stats, utils
Description: The package contains functions that can be used to compare
        expression measures on different array platforms.
License: GPL (>= 2)
URL: http://bioconductor.org
biocViews: Software, Technology, Microarray
git_url: https://git.bioconductor.org/packages/spkTools
git_branch: devel
git_last_commit: ff503f5
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:13:17 UTC; biocbuild

## summarize the results of the spkBox function
summarySpkBox <- function(boxs){
              meanFC <- sapply(boxs, mean, na.rm=TRUE)
              madFC <- sapply(boxs, function(x){if (!prod(is.na(x))) mad(x, na.rm=TRUE) else NA})
              return(data.frame(meanFC, madFC))
}

## function to determine empirical quantiles for the spikeins
spkQuantile <- function(amt, avgE, ens, p){
    obs <- as.vector(ens)
    N <- length(obs)
    M <- length(amt)
    q <- vector(length=M)
    out <- vector(length=2)
    for(i in 1:M){
        q[i] <- sum(obs<=avgE[i], na.rm=TRUE)/N
    }
    out[q <= p[1]] <- 1
    out[q <= p[2] & q > p[1]] <- 2
    out[q > p[2]] <- 3
    return(list(out=out, prop=q))
}

## quantification of the imbalance of the spike-in design
spkBal <- function(object){
              s <- spkSplit(object)$s
              n <- spikeIn(s)
              e <- exprs(s)
              n[is.na(n)] <- -99
              trts <- sort(unique(as.vector(n)))
              T <- length(trts)
              ## number of probes (U1) and arrays (U2)
              U1 <- nrow(n)
              U2 <- ncol(n)

              ## PROBE IMBALANCE:
              pExp <- U2^2 / T
              prbs <- apply(n,1,function(x) sum(table(x)^2))
              pBal <- sum(prbs-pExp) / U1

              ## ARRAY IMBALANCE:
              aExp <- U1^2 / T
              prbs <- apply(n,2,function(x) sum(table(x)^2))
              aBal <- sum(prbs-aExp) / U2

              out <- c(pBal,aBal)
              names(out) <- c("Probe Imbalance", "Array Imbalance")
              return(out)
          }

## boxplots of each comparison at a given fc
## generate breaks by spkSlope(object)$breaks
spkMA <- function(object, spkSlopeOut, fc=2, tol=3, label=NULL, ylim=NULL,
                   outlier=1, reduce=TRUE, plot.legend=TRUE){
              ## M: log ratio
              nsM <- spkPairNS(object,output="M")
              gc()
              ## determine which background probes are L,M,H
              brkpts <- spkSlopeOut$brkpts
              eMeans <- rowMeans(exprs(spkSplit(object)$ns), na.rm=TRUE)
              bgLowM <- as.vector(nsM[eMeans<brkpts[1], ])
              if(reduce){
                N <- length(bgLowM)
                M <- 5000
                bgLowMsort <- sort(bgLowM, index.return=TRUE)
                bgLowInd <- bgLowMsort$ix
                bgLowM <- bgLowMsort$x[seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              bgMedM <- as.vector(nsM[eMeans>=brkpts[1]&eMeans<brkpts[2], ])
              if(reduce){
                N <- length(bgMedM)
                M <- 5000
                bgMedMsort <- sort(bgMedM, index.return=TRUE)
                bgMedInd <- bgMedMsort$ix
                bgMedM <- bgMedMsort$x[seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              bgHighM <- as.vector(nsM[eMeans>=brkpts[2], ])
              if(reduce){
                N <- length(bgHighM)
                M <- 5000
                bgHighMsort <- sort(bgHighM, index.return=TRUE)
                bgHighInd <- bgHighMsort$ix
                bgHighM <- bgHighMsort$x[seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              rm(nsM)
              gc()
              ## A: avg exprs
              nsA <- spkPairNS(object,output="A")
              gc()
              ## determine which background probes are L,M,H
              brkpts <- spkSlopeOut$brkpts
              eMeans <- rowMeans(exprs(spkSplit(object)$ns), na.rm=TRUE)
              bgLowA <- as.vector(nsA[eMeans<brkpts[1], ])
              if(reduce){
                N <- length(bgLowA)
                M <- 5000
                bgLowA <- bgLowA[bgLowInd][seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              bgMedA <- as.vector(nsA[eMeans>=brkpts[1]&eMeans<brkpts[2], ])
              if(reduce){
                N <- length(bgMedA)
                M <- 5000
                bgMedA <- bgMedA[bgMedInd][seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              bgHighA <- as.vector(nsA[eMeans>=brkpts[2], ])
              if(reduce){
                N <- length(bgHighA)
                M <- 5000
                bgHighA <- bgHighA[bgHighInd][seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              rm(nsA)
              gc()
              ## now for spike-ins
              mafc <- spkPair(object)
              lfc <- round(log2(fc), digits=tol)
              ind <- round(mafc[,,3]-mafc[,,4],digits=tol)==lfc
              ind2 <- round(mafc[,,3]-mafc[,,4],digits=tol)==0
              ind[is.na(ind)] <- ind2[is.na(ind2)] <- FALSE
              sM <- mafc[,,1][ind]
              sA <- mafc[,,2][ind]
              nulM <- mafc[,,1][ind2]
              nulA <- mafc[,,2][ind2]
              N1 <- mafc[,,3][ind]
              nulN1 <- mafc[,,3][ind2]
              N2 <- mafc[,,4][ind]
              nulN2 <- mafc[,,4][ind2]
              ## which nominal concs are in which bins
              breaks <- spkSlopeOut$breaks
              low <- breaks[1,][breaks[2,]==1]
              med <- breaks[1,][breaks[2,]==2]
              high <- breaks[1,][breaks[2,]==3]
              ## populate the boxs
              M <- A <- list()
              M[[1]] <- c(bgLowM, -bgLowM)
              M[[2]] <- c(bgMedM, -bgMedM)
              M[[3]] <- c(bgHighM, -bgHighM)
              M[[4]] <- nulM[nulN1%in%low & nulN2%in%low]
              M[[5]] <- nulM[nulN1%in%med & nulN2%in%med]
              M[[6]] <- nulM[nulN1%in%high & nulN2%in%high]
              M[[7]] <- sM[N1%in%low & N2%in%low]
              M[[8]] <- sM[N1%in%med & N2%in%low]
              M[[9]] <- sM[N1%in%med & N2%in%med]
              M[[10]] <- sM[N1%in%high & N2%in%low]
              M[[11]] <- sM[N1%in%high & N2%in%med]
              M[[12]] <- sM[N1%in%high & N2%in%high]
              A[[1]] <- c(bgLowA, bgLowA)
              A[[2]] <- c(bgMedA, bgMedA)
              A[[3]] <- c(bgHighA, bgHighA)
              A[[4]] <- nulA[nulN1%in%low & nulN2%in%low]
              A[[5]] <- nulA[nulN1%in%med & nulN2%in%med]
              A[[6]] <- nulA[nulN1%in%high & nulN2%in%high]
              A[[7]] <- sA[N1%in%low & N2%in%low]
              A[[8]] <- sA[N1%in%med & N2%in%low]
              A[[9]] <- sA[N1%in%med & N2%in%med]
              A[[10]] <- sA[N1%in%high & N2%in%low]
              A[[11]] <- sA[N1%in%high & N2%in%med]
              A[[12]] <- sA[N1%in%high & N2%in%high]
              ## all background
              bgM <- c(M[[1]],M[[2]],M[[3]])
              bgA <- c(A[[1]],A[[2]],A[[3]])
              ind <- lapply(M,length)>0
              posxnames <- c("Bg-Null LL", "Bg-Null MM", "Bg-Null HH",
                             "S-Null LL", "S-Null MM", "S-Null HH",
                             "LL", "ML", "MM", "HL", "HM", "HH")
              xaxis <- posxnames[ind]
              i.spk <- which(xaxis%in%c("S-Null LL", "S-Null MM", "S-Null HH"))
              legend.names <- xaxis[-i.spk]
              nulpch <- 22
              spkpch <- 17
              spkcols <- brewer.pal(8,"Set1")[c(1,3,5:8)]
              nulcols <- brewer.pal(8,"Greys")[6:8]
              ifelse(is.null(label), ptitle <- paste("FC =", fc),
                     ptitle <- label)
              iOutlier <- bgM>=outlier | bgM<=-outlier
              if(is.null(ylim)){
                ylim <- c(min(unlist(M)),max(unlist(M)))
                smoothScatter(y=bgM[!iOutlier], x=bgA[!iOutlier],
                              main=ptitle, nrpoints=0,
                              xlab="A", ylab="M", ylim=ylim)
              } else{
                smoothScatter(y=bgM[!iOutlier], x=bgA[!iOutlier],
                              main=ptitle, nrpoints=0,
                              xlab="A", ylab="M", ylim=ylim)
              }
              points(y=bgM[iOutlier],x=bgA[iOutlier],pch=".",col="blue",cex=2)
              ## for(k in 1:3){
              ##   if(length(M[k])>0) points(y=M[[k+3]],x=A[[k+3]],pch=nulpch,col=nulcols[k],cex=.4)
              ## }
              for(k in 1:6){
                if(length(M[k])>0) points(y=M[[k+6]],x=A[[k+6]],pch=spkpch,col=spkcols[k],cex=.5)
              }
              ## pchs <- c(rep(nulpch,sum(ind[4:6])),rep(spkpch,sum(ind[7:12])))
              ## cols <- c(nulcols,spkcols)[ind[4:12]]
              pchs <- rep(spkpch,sum(ind[7:12]))
              cols <- spkcols[ind[7:12]]
              par(lwd=2,cex=1.5)
              ## determine how many bgs are present
              bgs <- vector(length=3)
              bgs[1] <- length(M[[1]])>0
              bgs[2] <- length(M[[2]])>0
              bgs[3] <- length(M[[3]])>0
              n.bg <- sum(bgs)              
              if(plot.legend){
                legend("bottomright", legend.names, pch=c(rep(15,n.bg),pchs),
                       col=c(rep("blue",n.bg),cols), ncol=2, cex=.8,
                       pt.cex=.8, box.lwd=1)
              }
          }

spkGNN <- function(n, n.expr, n.unexpr, AccuracySlope, AccuracySD, nullfc){
  nullfc <- nullfc[!is.na(nullfc)]
  
  N <- vector(length=10000)
  for(i in 1:10000){
    tmp <- sample(nullfc, n.unexpr, replace=TRUE)
    x <- qnorm(1-(n/n.expr), mean=AccuracySlope, sd=AccuracySD)
    n0 <- sum(tmp>x)
    N[i] <- n + n0
  }

  return(ceiling(mean(N)))
}

## plot the results of the spkBox function
plotSpkBox <- function(boxs, fc=2, box.names=NULL, ...){
              par(las=2, mar=c(5.5,4,4,2))
              if(!is.null(box.names)) names(boxs) <- box.names
              boxplot(boxs, pch="-",
                      ylab="Observed Log-Ratio", ...)
              abline(h=0,lty=3)
              abline(h=log2(fc),lty=3)
}

## compute all pairwise array comparisons for 1000 non-spikein probes
## only returns the positive fold change for each pairing
spkPairNS <- function(object,output="M"){
            tmp <- spkSplit(object)
            ns <- tmp$ns
            e <- exprs(ns)
            p <- combinations(n=ncol(e),r=2)
            m <- matrix(nrow=nrow(e),ncol=nrow(p))
            ## rows are probes
            ## cols are arraypairs
            if(output=="M"){
              for(k in 1:nrow(p)){
                m[,k] <- abs(e[,p[k,1]]-e[,p[k,2]])
              }
            }
            if(output=="A"){
              for(k in 1:nrow(p)){
                m[,k] <- (e[,p[k,1]]+e[,p[k,2]])/2
              }
            } 
            return(m)
          }
          

## variance of expression at each spikein level
spkVar <- function(object){
              tmp <- spkSplit(object)
              s <- tmp$s
              ns <- tmp$ns
              n <- spikeIn(s)
              e <- exprs(s)
              ens <- exprs(ns)
              lvls <- sort(unique(as.vector(n)))
              K <- length(lvls)
              V <- vector(length=K+1)
              for(k in 1:K){
                  ind <- n == lvls[k]
                  ind[is.na(ind)] <- FALSE
                  V[k] <- mad(as.vector(e[ind]), na.rm=TRUE)
              }
              V[K+1] <- mad(as.vector(ens), na.rm=TRUE)
              V <- cbind(c(lvls, "NonSpikeIns"), V)
              colnames(V) <- c("SpikeIn Amount", "MAD")
              return(V)
          }
          

## anova: expr ~ spike + array + probe + error
spkAnova <- function(object, model=expr~spike+probe+array){
              ## check model
              chk <- terms.formula(model)
              covs <- labels(chk)
              Y <- rownames(attr(chk, "factors"))[1]
              tst <- prod(covs %in% c("spike","probe","array"))
              tst2 <- (Y == "expr")
              if((tst*tst2) != TRUE) stop("Invalid model specification.")

              s <- spkSplit(object)$s
              n <- spikeIn(s)
              e <- exprs(s)
              ## computes number of replicate arrays
              ## NOTE: number of replicates must be a constant!
              ifelse("array"%in%covs, reps <- 1,
                      reps <- ncol(n)/sum(!duplicated(n,MARGIN=2)))

              ## data for lm fit
              nr <- nrow(e)
              nc <- ncol(e)
              dat <- data.frame(expr=as.vector(e), spike=as.factor(as.vector(n)),
                                array=as.factor(rep(1:nc, rep(nr,nc))), probe=as.factor(rep(1:nr,nc)))
              ## fit model
              options(contrasts=c("contr.sum","contr.sum"))
              fit <- lm(model, data=dat)

              ## compute SS
              ssr <- sum(fit$residuals^2)
              dfr <- df.residual(fit)
              comp <- fit$coef
              asgn <- fit$assign
              plus1 <- -unlist(lapply(split(comp, asgn), sum))[-1]
              comp <- c(comp,plus1)
              asgn <- c(asgn,1:length(plus1))
              ss <- c(unlist(lapply(split(comp^2, asgn), sum)), ssr)[-1]
              df <- c(unlist(lapply(split(asgn, asgn), length)), dfr)[-1]
              ms <- ss/(df+1)
              i <- length(ms)

              out <- sqrt(c(ms[-i]/reps,ms[i]))
              names(out) <- c(covs,"error")

              return(out)
          }

## signal detect slope for the entire datasets
## and for each bin -- low, med, high
spkSlope <- function(object, label=NULL, cuts=c(.6,.99), ...){
              ## set palette
              palette(brewer.pal(8,"Dark2"))
              tmp <- spkSplit(object)
              s <- tmp$s
              ns <- tmp$ns
              n <- spikeIn(s)
              e <- exprs(s)
              ens <- rowMeans(exprs(ns),na.rm=TRUE)
              ## regression of all the data
              Reg <- lm(as.vector(e)~as.vector(n))
              plot(x=jitter(as.vector(n)), y=as.vector(e),
                   xlab="Nominal Concentration",
                   ylab="Observed Expression Measure",
                   main=label, ...)
              ## compute means at each nom conc
              amt <- unique(as.vector(n))
              amt <- sort(amt[!is.na(amt)])
              avgE <- vector(length=length(amt))
              for(i in 1:length(amt)){
                  avgE[i] <- mean(e[n==amt[i]], na.rm=TRUE)
              }
            ## one bin
            if(is.null(cuts)){
              rSlps <- round(Reg$coef[2], digits=2)
              qout <- spkQuantile(amt, avgE, ens, p=c(0,1))
              brkpts <- c(-Inf,Inf)
              brks <- qout$out
              prop <- qout$prop
              ## plot slopes
              a <- Reg$coef[1]
              b <- Reg$coef[2]
              x0 <- min(amt[brks==min(brks)])
              x1 <- max(amt[brks==max(brks)])
              y0 <- a+b*x0
              y1 <- a+b*x1
              segments(x0, y0, x1, y1, col=3, lwd=4)
              ## legends
              txt <- paste("Slope:", rSlps[1])
              legend("bottomright", txt, col=3, lty=1, lwd=4, cex=.8,
                     bg="white")
              return(list(avgExp=avgE, slopes=rSlps, breaks=rbind(amt, brks),
                          brkpts=brkpts, prop=prop))
            }
            ## three bins  
            if(!is.null(cuts)){
              ## compute 3 slopes (low,med,high)
              qout <- spkQuantile(amt, avgE, ens, p=cuts)
              brkpts <- quantile(ens,probs=cuts,na.rm=TRUE)
              brks <- qout$out
              prop <- qout$prop
              B <- vector(length=3)
              lowInd <- n %in% amt[brks == 1]
              if(sum(brks == 1) > 1){
                  B[1] <- TRUE
                  lowE <- e[lowInd]
                  lowN <- n[lowInd]
                  lowReg <- lm(lowE~lowN)
              }
              medInd <- n %in% amt[brks == 2]
              if(sum(brks == 2) > 1){
                  B[2] <- TRUE
                  medE <- e[medInd]
                  medN <- n[medInd]
                  medReg <- lm(medE~medN)
              }
              highInd <- n %in% amt[brks == 3]
              if(sum(brks == 3) > 1){
                  B[3] <- TRUE
                  highE <- e[highInd]
                  highN <- n[highInd]
                  highReg <- lm(highE~highN)
              }
              ## plot slopes
              a <- Reg$coef[1]
              b <- Reg$coef[2]
              x0 <- min(amt[brks==min(brks)])
              x1 <- max(amt[brks==max(brks)])
              y0 <- a+b*x0
              y1 <- a+b*x1
              segments(x0, y0, x1, y1, col=3, lwd=4)
              if(B[1]){
                  a <- lowReg$coef[1]
                  b <- lowReg$coef[2]
                  x0 <- min(amt[brks==1])
                  x1 <- max(amt[brks==1])
                  y0 <- a+b*x0
                  y1 <- a+b*x1
                  segments(x0, y0, x1, y1, col=4, lwd=4)
              }
              if(B[2]){
                  a <- medReg$coef[1]
                  b <- medReg$coef[2]
                  x2 <- min(amt[brks==2])
                  x3 <- max(amt[brks==2])
                  y2 <- a+b*x2
                  y3 <- a+b*x3
                  segments(x2, y2, x3, y3, col=5, lwd=4)
              }
              if(B[3]){
                  a <- highReg$coef[1]
                  b <- highReg$coef[2]
                  x4 <- min(amt[brks==3])
                  x5 <- max(amt[brks==3])
                  y4 <- a+b*x4
                  y5 <- a+b*x5
                  segments(x4, y4, x5, y5, col=6, lwd=4)
              }

              ## add cut point lines
              if(B[1] & B[2]) abline(v=(x1+x2)/2, lty=2, lwd=3)
              if(B[2] & B[3]) abline(v=(x3+x4)/2, lty=2, lwd=3)

              rSlps <- rep(NA,4)
              rSlps[1] <- Reg$coef[2]
              if(B[1]) rSlps[2] <- lowReg$coef[2]
              if(B[2]) rSlps[3] <- medReg$coef[2]
              if(B[3]) rSlps[4] <- highReg$coef[2]
              rSlps <- round(rSlps, digits=2)
              names(rSlps) <- c("Total", "Low", "Med", "High")
              txt <- c(paste("Total:", rSlps[1]),
                       paste("Low:", rSlps[2]), paste("Med:", rSlps[3]),
                       paste("High:", rSlps[4]))
              legend("bottomright", txt, col=3:6, lty=1, lwd=4, cex=.8,
                     bg="white")
              return(list(avgExp=avgE, slopes=rSlps, breaks=rbind(amt, brks),
                          brkpts=brkpts, prop=prop))
            }
          }
          

setMethod("initialize", "SpikeInExpressionSet",
          function(.Object,
                   assayData = assayDataNew(exprs=exprs, spikeIn=spikeIn, ...),
                   exprs=new("matrix"),
                   spikeIn=new("matrix"),
                   phenoData = annotatedDataFrameFrom  (assayData, byrow=FALSE),
                   featureData = annotatedDataFrameFrom(assayData, byrow=TRUE),
                   experimentData = new("MIAME"),
                   annotation = new("character"), ...){
            .Object <- callNextMethod(.Object,
                                      assayData = assayData,
                                      phenoData = phenoData,
                                      experimentData = experimentData,
                                      annotation = annotation,
                                      featureData = featureData)
            .Object
          })

setMethod("createSpikeInExpressionSet",
          signature(object="SpikeInExpressionSet", exprs="matrix", spikeIn="matrix"),
          function(object, exprs, spikeIn, ...) new("SpikeInExpressionSet", exprs=exprs, spikeIn=spikeIn, ...))


setMethod("spikeIn", signature(object="SpikeInExpressionSet"),
          function(object) assayDataElement(object, "spikeIn")
          )

setReplaceMethod("spikeIn", signature(object="SpikeInExpressionSet", value="matrix"),
                 function(object, value) assayDataElementReplace(object, "spikeIn", value))

## function to make a new SpikeInExpressionSet object containing only
## the spiked in genes and one containing only the non-spiked in genes
setMethod("spkSplit", "SpikeInExpressionSet",
          function(object){
              ## genes spikedin on any of the arrays
              spk <- as.logical(apply(!is.na(spikeIn(object)), 1, sum,
                                      na.rm=TRUE))
              s <- new("SpikeInExpressionSet", exprs=exprs(object)[spk,],
                       spikeIn=spikeIn(object)[spk,])
              ns <- new("SpikeInExpressionSet", exprs=exprs(object)[!spk,],
                        spikeIn=spikeIn(object)[!spk,])
              list(s=s, ns=ns)
          }
          )

## estimate the sd for spike-ins at the lowest possible fc in each bin
spkAccSD <- function(object, spkSlopeOut, tol=3){
              breaks <- spkSlopeOut$breaks
              n <- m <- vector(length=3)
              for(k in 1:3){
                  tmp <- breaks[1,breaks[2,]==k]
                  n[k] <- length(tmp)
                  if (n[k] == 0) m[k] <- NA else m[k] <- round(min(tmp[2:n[k]]-tmp[1:(n[k]-1)]), tol)
              }

              um <- unique(round(m, tol))
              um <- um[!is.na(um)]
              N <- length(um)
              MADs <- matrix(nrow=3, ncol=N)
              for(k in 1:N){
                  fc <- round(um[k], digits=tol)
                  mafc <- spkPair(object)
                  ind <- round(mafc[,,3]-mafc[,,4], digits=tol)==fc
                  ind[is.na(ind)] <- FALSE
                  sM <- mafc[,,1][ind]
                  N1 <- mafc[,,3][ind]
                  N2 <- mafc[,,4][ind]
                  ## which nominal concs are in which bins
                  low <- breaks[1,][breaks[2,]==1]
                  med <- breaks[1,][breaks[2,]==2]
                  high <- breaks[1,][breaks[2,]==3]
                  ## populate the boxs
                  boxs <- list()
                  boxs[[1]] <- sM[N1%in%low & N2%in%low]
                  boxs[[2]] <- sM[N1%in%med & N2%in%med]
                  boxs[[3]] <- sM[N1%in%high & N2%in%high]
                  ind <- lapply(boxs,length)==0
                  MADs[,k] <- sapply(boxs, function(x){if (!prod(is.na(x))) mad(x, na.rm=TRUE) else NA})
              }
              madFC <- vector(length=3)
              names(madFC) <- c("LL","MM","HH")
              for(k in 1:3){
                if (is.na(m[k])) madFC[k] <- NA else madFC[k] <- MADs[k,which(um==m[k])]
              }
              return(madFC)
            }

## generic functions
setGeneric("spikeIn", function(object) standardGeneric("spikeIn"))
setGeneric("spkSplit", function(object) standardGeneric("spkSplit"))
setGeneric("spikeIn<-", function(object, value) standardGeneric("spikeIn<-"))
setGeneric("createSpikeInExpressionSet",
           function(object, exprs, spikeIn, ...) standardGeneric("createSpikeInExpressionSet"))

## boxplots of each comparison at a given fc
## generate breaks by spkSlope(object)$breaks
spkBox <- function(object, spkSlopeOut, fc=2, tol=3, reduce=TRUE){
              nsM <- spkPairNS(object)
              gc()
              ## determine which background probes are L,M,H
              brkpts <- spkSlopeOut$brkpts
              eMeans <- rowMeans(exprs(spkSplit(object)$ns), na.rm=TRUE)
              if(brkpts[1] > -Inf){
                bgLow <- as.vector(nsM[eMeans<brkpts[1], ])
                if(reduce){
                  N <- length(bgLow)
                  M <- 5000
                  bgLow <- sort(bgLow)[seq(N/(2*M),N-N/(2*M),len=M)]
                }
                gc()
              } else bgLow <- numeric(0)
              bgMed <- as.vector(nsM[eMeans>=brkpts[1]&eMeans<brkpts[2], ])
              if(reduce){
                N <- length(bgMed)
                M <- 5000
                bgMed <- sort(bgMed)[seq(N/(2*M),N-N/(2*M),len=M)]
              }
              gc()
              if(brkpts[2] < Inf){
                bgHigh <- as.vector(nsM[eMeans>=brkpts[2], ])
                if(reduce){
                  N <- length(bgHigh)
                  M <- 5000
                  bgHigh <- sort(bgHigh)[seq(N/(2*M),N-N/(2*M),len=M)]
                }
                gc()
              } else bgHigh <- numeric(0)
              rm(nsM)
              gc()
              ## now for spike-ins
              mafc <- spkPair(object)
              lfc <- round(log2(fc), digits=tol)
              ind <- round(mafc[,,3]-mafc[,,4],digits=tol)==lfc
              ind2 <- round(mafc[,,3]-mafc[,,4],digits=tol)==0
              ind[is.na(ind)] <- ind2[is.na(ind2)] <- FALSE
              sM <- mafc[,,1][ind]
              nulM <- mafc[,,1][ind2]
              N1 <- mafc[,,3][ind]
              nulN1 <- mafc[,,3][ind2]
              N2 <- mafc[,,4][ind]
              nulN2 <- mafc[,,4][ind2]
              ## which nominal concs are in which bins
              breaks <- spkSlopeOut$breaks
              low <- breaks[1,][breaks[2,]==1]
              med <- breaks[1,][breaks[2,]==2]
              high <- breaks[1,][breaks[2,]==3]
              ## populate the boxs
              boxs <- list()
              boxs[[1]] <- c(bgLow, -bgLow)
              boxs[[2]] <- c(bgMed, -bgMed)
              boxs[[3]] <- c(bgHigh, -bgHigh)
              boxs[[4]] <- nulM[nulN1%in%low & nulN2%in%low]
              boxs[[5]] <- nulM[nulN1%in%med & nulN2%in%med]
              boxs[[6]] <- nulM[nulN1%in%high & nulN2%in%high]
              boxs[[7]] <- sM[N1%in%low & N2%in%low]
              boxs[[8]] <- sM[N1%in%med & N2%in%low]
              boxs[[9]] <- sM[N1%in%med & N2%in%med]
              boxs[[10]] <- sM[N1%in%high & N2%in%low]
              boxs[[11]] <- sM[N1%in%high & N2%in%med]
              boxs[[12]] <- sM[N1%in%high & N2%in%high]
              ## which bins to include
              ind <- lapply(boxs,length)==0
              posxnames <- c("Bg-Null LL", "Bg-Null MM", "Bg-Null HH",
                             "S-Null LL", "S-Null MM", "S-Null HH", "LL", "ML",
                             "MM", "HL", "HM", "HH")
              boxs[ind] <- NULL
              names(boxs) <- posxnames[!ind]
              return(boxs)
          }

## compute all pairwise array comparisons for spikein probes
spkPair <- function(object){
            tmp <- spkSplit(object)
            s <- tmp$s
            e <- exprs(s)
            n <- spikeIn(s)
            p <- permutations(n=ncol(n),r=2)
            mafc <- array(dim=c(nrow(n),nrow(p),4),dimnames=list("probes"=rownames(n), "arraypairs"=1:nrow(p),"stats"=c("M","A","N1","N2")))
            for(k in 1:nrow(p)){
              e1 <- e[,p[k,1]]
              e2 <- e[,p[k,2]]
              mafc[,k,1] <- e1-e2
              mafc[,k,2] <- (e1+e2)/2
              mafc[,k,3] <- n[,p[k,1]]
              mafc[,k,4] <- n[,p[k,2]]
            }
            rownames(mafc) <- rownames(e)
            return(mafc)
          }

## plot a density curve of the non-spike-in genes and a multicolor rug for the
## density of the spike-in genes
spkDensity <- function(object, spkSlopeOut, cuts=TRUE, label=NULL, ...){
              avgExp <- spkSlopeOut$avgExp
              tmp <- spkSplit(object)
              s <- tmp$s
              ns <- tmp$ns
              es <- exprs(s)
              nes <- exprs(ns)
              nsden <- density(nes, adjust=3, na.rm=TRUE)
              if(!"xlim"%in%objects()) xlim <- c(min(c(es, nes), na.rm=TRUE), max(c(es, nes), na.rm=TRUE))
              plot(nsden, xlab="Observed Expression Measure",
                   ylab="Density", main=label, ...)
              rug(avgExp)
           if(cuts){
              brkpts <- spkSlopeOut$brkpts
              abline(v=brkpts[1], lty=3)
              abline(v=brkpts[2], lty=3)
            }
          }
          

## wrapper for spikein functions
spkAll <- function(object, label, model=expr~spike+probe+array, fc=NULL,
                   tol=3, xrngs=NULL, yrngs=NULL, cuts=c(.6,.99),
                   potQuantile=.995, gnn=c(25,100,10000), pch=".", output="eps"){
            mypar <- function(a=1,b=1,brewer.n=8,brewer.name="Dark2",...){
              par(mar=c(2.5,2.5,1.6,1.1),mgp=c(1.5,.5,0))
              par(mfrow=c(a,b),...)
              palette(brewer.pal(brewer.n,brewer.name))
            }
            ## output label
            olab <- paste(strsplit(label, " ")[[1]], collapse="")
            
              ## Figure 1 - Slope Plot
              cat("Generating slope plot... ")
              if(output=="eps") postscript(paste("slope", olab, ".eps",
                   sep=""), horizontal=FALSE, encoding="TeXtext.enc",
                   pointsize=15, width=8, height=8)
              if(output=="pdf") pdf(paste("slope", olab, ".pdf", sep=""),
                   pointsize=15, width=8, height=8)
              mypar(mar=c(2.5,2.5,2,0.5), cex=1.8)
              ss <- spkSlope(object, label, cuts=cuts, pch=pch,
                             xlim=xrngs$s, ylim=yrngs$s)
              dev.off()
              cat("Done\n")

              ## Figure 2 - Density Plot
              cat("Generating density plot... ")
              if(output=="eps") postscript(paste("density", olab, ".eps",
                   sep=""), horizontal=FALSE, encoding="TeXtext.enc",
                   pointsize=15, width=8, height=8)
              if(output=="pdf") pdf(paste("density", olab, ".pdf", sep=""),
                   pointsize=15, width=8, height=8)
              mypar(mar=c(2.5,2.5,2,0.5), cex=1.8)
              drawcuts <- !is.null(cuts)
              spkDensity(object, ss, drawcuts, label,
                         xlim=xrngs$d, ylim=yrngs$d)
              dev.off()
              cat("Done\n")

              ## Table 1
              cat("Generating table 1... ")
              vtmp <- spkVar(object)
              sv <- as.numeric(vtmp[,2][-nrow(vtmp)])
              bin <- c("Low", "Med", "High")
              bins <- bin[ss$breaks[2,]]
              tab1 <- data.frame(NominalConc=2^ss$breaks[1,],
                                 AvgExp=round(ss$avgExp,1),
                                 PropGenesBelow=round(ss$prop,2),
                                 ALEStrata=bins,
                                 SD=round(sv,2))
              write.csv(tab1, file=paste("spkT1", olab, ".csv", sep=""),
                        row.names=FALSE)
              cat("Done\n")

              ## Figure 3 - Boxplots
              if(!is.null(fc) & !is.null(cuts)){
                  cat("Generating fold change plots... ")
                  spkBoxOut <- spkBox(object, spkSlopeOut=ss, fc=fc,
                                 tol=tol)
                  if(output=="eps") postscript(paste("FC", fc, "box", olab,
                       ".eps", sep=""), horizontal=FALSE,
                       encoding="TeXtext.enc", pointsize=15, width=8, height=8)
                  if(output=="pdf") pdf(paste("FC", fc, "box", olab, ".pdf",
                       sep=""), pointsize=15, width=8, height=8)
                  mypar(mar=c(5.2,2.5,2,0.5), cex=1.8)
                  plotSpkBox(spkBoxOut, fc=fc, xlim=xrngs$v, ylim=yrngs$v, main=label)
                  dev.off()
                  sbox <- summarySpkBox(spkBoxOut)
                  cat("Done\n")
                  
              ## Table 2
                  cat("Generating table 2... ")
                  AccuracySlope <- round(ss$slopes[-1], digits=2)
                  AccuracySD <- round(spkAccSD(object, ss), digits=2)
                  pot <- spkPot(object, ss, AccuracySlope, AccuracySD,
                                potQuantile)
                  PrecisionSD <- round(sbox$madFC[1:3], digits=2)
                  PrecisionQuantile <- round(pot$quantiles, digits=2)
                  SNR <- round(AccuracySlope/PrecisionSD, digits=2)
                  POT <- round(pot$POTs, digits=2)
                  GNN <- vector(length=3)
                  for(k in 1:3){
                    GNN[k] <- spkGNN(n=gnn[1], n.expr=gnn[2], n.unexpr=gnn[3],
                                     AccuracySlope[k], AccuracySD[k], spkBoxOut[[k]])
                  }
                  tab2 <- data.frame(AccuracySlope=AccuracySlope,
                                     AccuracySD=AccuracySD,
                                     PrecisionSD=PrecisionSD,
                                     PrecisionQuantile=PrecisionQuantile,
                                     SNR=SNR,
                                     POT=POT,
                                     GNN=GNN)
                  write.csv(tab2, file=paste("spkT2", olab, ".csv", sep=""),
                            row.names=c("Low","Med","High"))
                  cat("Done\n")
                  
              ## Figure 4 - MA plots
                  cat("Generating MA plots... ")
                  if(output=="eps") postscript(paste("FC", fc, "MA", olab,
                       ".eps", sep=""), horizontal=FALSE,
                       encoding="TeXtext.enc", pointsize=15, width=8, height=8)
                  if(output=="pdf") pdf(paste("FC", fc, "MA", olab, ".pdf",
                       sep=""), pointsize=15, width=8, height=8)
                  mypar(mar=c(5.2,2.5,2,0.5), cex=1.8)
                  spkMA(object, label=label, spkSlopeOut=ss, fc=fc,
                        tol=tol, ylim=yrngs$m)
                  dev.off()
                  cat("Done\n")
                }
            
              ## Limited Figure 3 & Table 2
              if(!is.null(fc) & is.null(cuts)){
                  cat("Generating fold change plots... ")
                  spkBoxOut <- spkBox(object, spkSlopeOut=ss, fc=fc,
                                 tol=tol)
                  if(output=="eps") postscript(paste("FC", fc, "box", olab,
                       ".eps", sep=""), horizontal=FALSE,
                       encoding="TeXtext.enc", pointsize=15, width=8, height=8)
                  if(output=="pdf") pdf(paste("FC", fc, "box", olab, ".pdf",
                       sep=""), pointsize=15, width=8, height=8)
                  mypar(mar=c(5.2,2.5,2,0.5), cex=1.8)
                  plotSpkBox(spkBoxOut, fc=fc, xlim=xrngs$v,
                              ylim=yrngs$v, main=label)
                  dev.off()
                  sbox <- summarySpkBox(spkBoxOut)
                  cat("Done\n")
                  
              ## Table 2
                  cat("Generating table 2... ")
                  AccuracySlope <- c(NA, round(ss$slopes, digits=2), NA)
                  AccuracySD <- round(spkAccSD(object, ss), digits=2)
                  pot <- spkPot(object, ss, AccuracySlope, AccuracySD,
                                potQuantile)
                  PrecisionSD <- round(sbox$madFC[1], digits=2)
                  PrecisionQuantile <- round(pot$quantiles, digits=2)
                  SNR <- round(AccuracySlope/PrecisionSD, digits=2)
                  POT <- round(pot$POTs, digits=2)
                  GNN <- spkGNN(n=gnn[1], n.expr=gnn[2], n.unexpr=gnn[3],
                                AccuracySlope[2], AccuracySD[2],
                                spkBoxOut[[2]])
                  tab2 <- data.frame(AccuracySlope=AccuracySlope[2],
                                     AccuracySD=AccuracySD[2],
                                     PrecisionSD=PrecisionSD,
                                     PrecisionQuantile=PrecisionQuantile[2],
                                     SNR=SNR[2],
                                     POT=POT[2],
                                     GNN=GNN)
                  write.csv(tab2, file=paste("spkT2", olab, ".csv", sep=""),
                            row.names=c("Total"))
                  cat("Done\n")

              ## Figure 4 - MA plots
                  cat("Generating MA plots... ")
                  if(output=="eps") postscript(paste("FC", fc, "MA", olab,
                       ".eps", sep=""), horizontal=FALSE,
                       encoding="TeXtext.enc", pointsize=15, width=8, height=8)
                  if(output=="pdf") pdf(paste("FC", fc, "MA", olab, ".pdf",
                       sep=""), pointsize=15, width=8, height=8)
                  mypar(mar=c(5.2,2.5,2,0.5), cex=1.8)
                  spkMA(object, label=label, spkSlopeOut=ss, fc=fc,
                        tol=tol, ylim=yrngs$m, reduce=FALSE)
                  dev.off()
                  cat("Done\n")
                }
            
              ## Table 3
              cat("Generating table 3... ")
              bals <- round(spkBal(object))
              anv <- round(spkAnova(object, model), digits=2)
              tab3 <- t(c(anv,bals))
              write.csv(tab3, file=paste("spkT3", olab, ".csv", sep=""),
                        row.names=FALSE)
              cat("Done\n")
          }

spkPot <- function(object, spkSlopeOut, sig, SD, precisionQuantile=.995){
    nsM <- spkPairNS(object)
    gc()
    ## determine which background probes are L,M,H
    brkpts <- spkSlopeOut$brkpts
    eMeans <- rowMeans(exprs(spkSplit(object)$ns))
    gc()
    ## compute quantiles
    p9 <- vector(length=3)
    bgHigh <- as.vector(nsM[eMeans>=brkpts[2], ])
    p9[3] <- quantile(bgHigh,probs=precisionQuantile,na.rm=TRUE)
    rm(bgHigh)
    gc()
    bgMed <- as.vector(nsM[eMeans>=brkpts[1]&eMeans<brkpts[2], ])
    p9[2] <- quantile(bgMed,probs=precisionQuantile,na.rm=TRUE)
    rm(bgMed)
    gc()
    bgLow <- as.vector(nsM[eMeans<brkpts[1], ])
    rm(nsM)
    gc()
    p9[1] <- quantile(bgLow,probs=precisionQuantile,na.rm=TRUE)
    rm(bgLow)
    gc()
    ## compute POTs
    POTs <- vector(length=3)
    POTs[1] <- 1-pnorm(p9[1], mean=sig[1], sd=SD[1])
    POTs[2] <- 1-pnorm(p9[2], mean=sig[2], sd=SD[2])
    POTs[3] <- 1-pnorm(p9[3], mean=sig[3], sd=SD[3])
    return(data.frame(quantiles=p9, POTs=POTs))
}

% automatic manuscript creation for spkTools
% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{spkTools: Spike-in Data Analysis and Visualization}
%\VignetteDepends{Biobase,RColorBrewer,gtools,xtable}
%\VignettePackage{spkTools}
\documentclass[12pt]{article}
\usepackage{hyperref}
\usepackage[authoryear, round]{natbib}

\textwidth=6.2in
\textheight=8.5in
\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand\Rpackage[1]{{\textsf{#1}\index{#1 (package)}}}
\newcommand\dataset[1]{{\textit{#1}\index{#1 (data set)}}}
\newcommand\Rclass[1]{{\textit{#1}\index{#1 (class)}}}
\newcommand\Rfunction[1]{{{\small\texttt{#1}}\index{#1 (function)}}}
\newcommand\Rfunarg[1]{{\small\texttt{#1}}}
\newcommand\Robject[1]{{\small\texttt{#1}}}

\author{Matthew N. McCall}

\begin{document}
\title{Tools for Spike-in Data Analysis and Visualization (spkTools)}
\maketitle
\tableofcontents

\section{Introduction}
  As the number of users of microarray technology continues to grow,
  so does the importance of platform assessments and
  comparisons. Spike-in experiments have been successfully used for
  internal technology assessments by microarray manufacturers and for
  comparisons of competing data analysis approaches. The microarray
  literature is saturated with statistical assessments based on
  spike-in experiment data. Unfortunately, the statistical assessments
  vary widely and are applicable only in specific cases. This has
  introduced confusion into the debate over best practices with
  regards to which platform, protocols, and data analysis tools are
  best. Furthermore, cross-platform comparisons have proven difficult
  because reported concentrations are not comparable. We present a
  novel statistical solution that enables cross-platform comparisons,
  and propose a comprehensive procedure for assessments based on
  spike-in experiments. The ideas are implemented in a user friendly
  Bioconductor package: \Rpackage{spkTools}.

  This document describes \Rpackage{spkTools}, which implements
  the methods suggested in the Nucleic Acids Research paper,
  \emph{Consolidated strategy for the analysis of microarray spike-in data}
  (McCall \& Irizarry 2008). While ideally someone interested in using
  this package would use that paper as a guide, sections relating specifically to
  the \Rpackage{spkTools} package are included here.

\section{SpikeInExpressionSet}
  This package defines a new S4 class that extends the
  \Rclass{ExpressionSet} class to include a matrix of
  nominal concentrations; this new class is called a
  \Rclass{SpikeInExpressionSet}. The functions implemented in this
  package take an object of this type as their input and
  produce the tables and plots presented in this paper. Of particular
  interest is the function \Rfunction{spkAll}, which is a wrapper
  function for all the functions contained in this package. When run
  on a \Rclass{SpikeInExpressionSet} object, it produces the full
  complement of tables and plots shown in this paper and saves them
  with easily recognizable file-names. Although this package was
  designed with the intent of producing the full array of results for
  each experiment, the functions can also be applied separately with a
  few exceptions where the output of one function is required as the
  input of another.

\section{spkTools Methods}

\subsection{Relating nominal concentrations across data sets}
  Our solution to the problem of mapping was to replace each nominal
  concentration with the average log expression across arrays (ALE)
  for genes spiked in at that concentration.  This approach assures
  that performance assessments based on spike-in data are related to
  expression measurements that are defined consistently across
  platforms: low, medium, and high ALE values correspond to low,
  medium, and high observed expression values respectively.

\subsection{Accuracy assessment}
With the ALE values in place, we were ready to adapt some of the
existing statistical assessments to cross-platform comparisons. We
started with a basic assessment of accuracy: the \emph{signal
  detection slope}. Microarrays are designed to
  measure the abundance of sample RNA. In principle, we expect a
  doubling of nominal concentration to result in a doubling of
  observed intensity. In other words, on the $\log_{2}$ scale, the
slope from the regression of expression on nominal concentration can
be interpreted as the expected observed difference when the true
difference is a fold change of 2. Thus, an optimal result is a slope
of one, and values higher and lower than one are associated with over
and under estimation respectively.

\subsection{ALE strata}
It has been noted that at very high and very low concentrations one
typically observes lower slopes compared to those seen at medium
concentrations. To address this, we consider the
signal detection slopes for genes spiked-in at low, medium, and high
ALE values. We implemented a data-driven approach to selecting
  these two cut-offs.

We defined $f$ to be the function that maps nominal log
  concentration $x$ to expected observed concentration $f(x)$. Using a
  cubic spline, fitted to the observed data, we obtained a parametric
  representation of $f$. We then looked for concentrations for which
  clear changes in sensitivity occurred, i.e. values of $x$ with large
  slope changes. Note that large changes in slope result in local
  maxima in the absolute value of the second derivative of $f$. For
  each platform, the absolute value of the second derivative $f''$
  showed two clear local maxima. For each
  platform we mapped each concentration $x$ to its corresponding
  empirical percentile $\Phi(x)$ and plotted $|f''(x)|$ against
  $\Phi(x)$. The percentiles that maximized
  the slope change were similar across platforms. The modes for the
  average curve were 0.615 and 0.993. Therefore, for the purpose of
  this comparison, we assigned as \emph{low}, ALE values less than the
  60th percentile of the distribution of background RNA. Similarly we
  defined as \emph{high} ALE values above the 99th percentile. The
  remaining ALE values, between the 60th and 99th percentile, were
  denoted as \emph{medium}. Our choice of cut-points was further
  motivated by observing that for the Affymetrix data the 60th
  percentile provided a good cut-off for distinguishing genes called
  present from genes called absent.

\subsection{Precision assessments}
To complete our comparison we needed to assess specificity. Because the
majority of microarray studies rely on relative measures (e.g. fold
change) as opposed to absolute ones, we focused on the precision of
the basic unit of relative expression: log-ratios.  We adapted the
precision assessment of Cope et al. that focused on
the variability of log-ratios generated by comparisons expected to
produce log-ratios of 0.  Our set of comparisons was created by making
all possible comparisons between spiked-in transcripts across arrays
in which they had the same nominal concentration and from all possible
comparisons within the background RNA. We referred to this group of
comparisons as the \emph{Null} set. The standard deviation (SD) of
these log-ratios served as a basic assessment of precision and has a
useful interpretation: it is the expected range of observed log-ratios
for genes that are not differentially expressed. 

Because specificity varies with nominal concentration, we stratified
these comparisons into low, medium, and high ALE values. Many outliers
were observed on each platform. This was expected given the documented
problem of cross-hybridization. Because a platform with larger SD and
small outliers might be preferable to one with a smaller SD but large
outliers we included the 99.5th percentile of the null distribution as
a second summary assessment of specificity. Note that in a typical
experiment close to 0.5\% of null genes are expected to exceed this
value, which translates to approximately 100 genes on whole genome
arrays. We also included comparisons of spike-ins expected to
yield a certain fold change. These serve to further demonstrate the
variability of relative expression across ALE strata. They also serve
as a rough illustration of the accuracy of log-ratios for each ALE
strata.

\subsection{Performance assessments}
Precision and accuracy assessments on their own may not be of much
practical use. However, the summary statistics described above can be easily combined to answer any practical question, as long as
it can be posed in a statistical context. We focus on two summaries
  related to the common problem of detecting differentially expressed
  genes. Note that we purposely developed summaries that do not
  directly penalize for a lack of accuracy and precision as long as the
  real differences are detected. However, as expected, detection
  ability was highly dependent on accuracy and precision.

For the first example, we computed the chance that, when comparing two
samples, a gene with true log fold change $\Delta=1$ will appear in a
list of the top 100 genes (highest log-ratios). We refer to this
quantity as the \emph{probability of being at the top} (POT) and
recommend computing it separately in each ALE strata. Specifically, we
assume that the log-ratios in each ALE strata follow a normal
distribution with mean and variance estimated from the data (accuracy
slope and standard deviation) and compute the probability
that a random variable from that distribution exceeds the 99.5th
percentile of the null distribution.

As a second example, we computed the expected size of a gene list
  one would have to consider to find $n$ genes that have a true log
  fold change $\Delta$. To perform this calculation we assumed $m_1$
  genes were differentially expressed and $m_0$ were not. Note that
  $m_1+m_0$ is the number of genes on the array. Furthermore, we
  assumed that the true log-ratios in each ALE strata followed a
  normal distribution with mean and variance estimated from the data
  (accuracy slope and standard deviation). The empirical
  distribution was used for the null genes.  With these assumptions in
  place we computed the gene list size for $n=10$, $m_1=100$, and
  $m_0=10000$, we calculate the gene list size, $N$, required to
  obtain $n=10$ true fold changes.  We refer to this
  quantity as the \emph{gene-list needed to detect $n$ true-positives
    (GNN)}. Again, we recommend computing it separately in each ALE
  strata.

\subsection{Imbalance measure} 
Those interested in taking advantage of our methodology should know
that an important requirement is a spike-in experimental design that
does not confound nominal concentrations and genes. A large source of
variability in microarray data is the probe-effect and these vary
across platforms. We fitted an ANOVA model to describe the probe
effect for each platform. Note that if nominal concentrations are
confounded with genes, it becomes impossible to separate differences
due to signal detection from differences in probe affinities. Many of
the previously published spike-in experiments suffer from this
confounding effect. To quantify design imbalance we used the following
measure of imbalance developed by Wu (1981):
\begin{equation}
IB = \sum_{i=1}^p \lambda_{i} \sum_{u_{i}}^{r_{i}} \Big( \sum_{t=1}^T
n_{t}^2(u_{i})-\frac{1}{T}n^2(u_i) \Big)
\end{equation}
where $i$ denotes each covariate, $\lambda_{i}$ an optional weight
associated with each covariate, $u_{i}$ are the possible levels for
covariate $i$, $t$ represents the treatment levels, $n_{t}(u_{i})$ is
the number of units with its $i$th covariate at level $u_{i}$
receiving treatment $t$, and $n(u_{i})$ is the total number of units
with its $i$th covariate at level $u_{i}$. In our
case, the two covariates are probe and array, and the treatment is
nominal concentration. Since imbalance is defined as a weighted sum of
the imbalance due to each covariate, we chose to report the probe and
array imbalance separately to give a better understanding of the
source of the imbalance in each design. In order to not penalize large
designs, we divided the probe imbalance by the number of probes and
the array imbalance by the number of arrays. 

\section{Example}

<<echo=T,results=hide>>=
library(spkTools)
@ 
Load a SpikeInExpressionSet object :
<<echo=T,results=hide>>=
data(affy)
object <- affy
@ 

Set a few parameters:
<<echo=T,results=hide>>=
fc=2
label="Affymetrix"
par(mar=c(3,2.5,2,0.5), cex=1.8)
@ 

\newpage

\begin{figure}[!h]
\begin{center}
<<fig=TRUE,echo=T>>=
spkSlopeOut <- spkSlope(object, label, pch="+")
@
\end{center} {{\bf Observed versus nominal values}: This plot
  depicts expression values plotted against the log (base 2) of the
  reported nominal concentration. The regression slope obtained
  utilizing all the data and the regression slopes obtained within each
  ALE value strata are shown. The slope of each line is reported in
  the legend. The vertical lines divide the ALE strata.}
\end{figure}

\newpage

\begin{figure}[!h]
\begin{center}
<<fig=TRUE,echo=T>>=
spkDensity(object, spkSlopeOut, cuts=TRUE, label)
@
\end{center} {{\bf Empirical densities}: This plot depicts the
  empirical density of the average (across arrays) expression values
  for the background RNA. The tick marks on the x-axis show the
  average expression at each nominal concentration. The dotted lines
  represent the cut points for low, medium, and high ALE values.}
\end{figure}

\newpage

\begin{figure}[!h]
\begin{center}
<<echo=T,fig=T>>=
spkBoxOut <- spkBox(object, spkSlopeOut, fc)
plotSpkBox(spkBoxOut, fc, ylim=c(-1.5,2.5))
sbox <- summarySpkBox(spkBoxOut)
@
\end{center} {{\bf Log-ratio distributions}: This plot depicts
  the distribution of observed log ratios for a given nominal fold
  change. The log ratios are stratified by the ALE strata into which
  the two nominal concentrations fall. The null distributions'
  log-ratios are divided into background RNA (Bg-Null) and spike-ins
  at the same nominal concentration (S-Null), for each bin. The dotted
  horizontal lines represent the expected or nominal log-ratios: zero
  for the null distribution and one for the other comparisons.}
\end{figure}

\newpage

\begin{figure}[!h]
\begin{center}
<<echo=T,fig=T>>=
spkMA(object, spkSlopeOut, fc, label=label, ylim=c(-2.5,2.5))
@ 
\end{center} {{\bf MA plots}: For each platform, we performed all
  pair-wise comparisons of the arrays. From each comparison we
  computed the log-ratio (M) and average expression value (A) for each
  gene. These plots show M plotted against A. To avoid drawing
  hundreds of points on top of each other we use a smooth scatter plot
  which shows the distribution of these points: dark and light shades
  of blue show high and low concentrations of points
  respectively. Points not associated with the spike-in transcripts
  (expected M=0) that achieved fold changes above 2 are shown as large
  blue dots. The points associated with spike-in transcripts with
  nominal fold changes of 2 are shown as triangles. The different
  colors denote the ALE groups.}
\end{figure}

\newpage

<<results=tex,echo=T>>=
vtmp <- spkVar(object)
sv <- as.numeric(vtmp[,2][-nrow(vtmp)])
bin <- c("Low", "Med", "High")
bins <- bin[spkSlopeOut$breaks[2,]]
tab1 <- data.frame(NominalConc=2^spkSlopeOut$breaks[1,],
                   AvgExp=round(spkSlopeOut$avgExp,1),
                   PropGenesBelow=round(spkSlopeOut$prop,2),
                   ALEStrata=bins,
                   SD=round(sv,2))
colnames(tab1) <- c("Nominal Conc",
                    "Avg Expression",
                    "Prop of Genes Below",
                    "ALE Strata",
                    "Std Dev")
@ 

<<results=tex,echo=F>>=
library(xtable)
tab1x <- xtable(tab1)
print(tab1x)
@ 
{{\bf Nominal concentration to ALE mapping}: This table contains
  summary measures specific to each nominal spike-in level.  The first
  column shows the nominal concentrations as originally reported. The
  second column shows the average of all observed expression values
  associated with the row's nominal concentration. The third column
  shows the proportion of background RNA with expression values less
  than the average expression value. The fourth column shows the ALE
  strata associated with the row's nominal
  concentration.  Finally, the fifth column shows the standard
  deviation of all observed expression values associated with the
  row's nominal concentration.}

\newpage

<<results=tex,echo=T>>=
AccuracySlope <- round(spkSlopeOut$slopes[-1], digits=2)
AccuracySD <- round(spkAccSD(object, spkSlopeOut), digits=2)
pot <- spkPot(object, spkSlopeOut, AccuracySlope, AccuracySD, 
              precisionQuantile=.995)
PrecisionSD <- round(sbox$madFC[1:3], digits=2)
PrecisionQuantile <- round(pot$quantiles, digits=2)
SNR <- round(AccuracySlope/PrecisionSD, digits=2)
POT <- round(pot$POTs, digits=2)
tab2 <- data.frame(AccuracySlope=AccuracySlope,
                   AccuracySD=AccuracySD,
                   PrecisionSD=PrecisionSD,
                   PrecisionQuantile=PrecisionQuantile,
                   SNR=SNR,
                   POT=POT)
@ 
<<results=tex,echo=F>>=
tab2x <- xtable(tab2)
print(tab2x)
@ 
{{\bf Assessment results}: For each of the ALE strata we
  report summary assessments for accuracy, precision, and overall
  performance. The first column shows the signal detection slope which
  can be interpreted as the expected observed difference when the true
  difference is a fold change of 2. In parenthesis is the standard
  deviation of the log-ratios associated with non-zero nominal
  log-ratios. The second column shows the standard deviation of null
  log-ratios. The SD can be interpreted as the expected range of
  observed log-ratios for genes that are not differentially
  expressed. The third column shows the 99.5th percentile of the null
  distribution. It can be interpreted as the expected minimum value
  that the top 100 non-differentially expressed genes will reach. The
  fourth column shows the ratio of the values in column 1 and column
  2. It is a rough measure of signal to noise ratio. The fifth column
  shows the probability that, when comparing two samples, a gene with
  a true log fold change of 2 will appear in a list of the 100 genes
  with the highest log-ratios.}

\newpage

<<results=tex,echo=T>>=
bals <- round(spkBal(object))
anv <- round(spkAnova(object), digits=2)
tab3 <- t(c(anv,bals))
@ 
<<results=tex,echo=F>>=
tab3x <- xtable(tab3)
print(tab3x)
@ 
{{\bf ANOVA results}: To understand the variability contributed by
  differences in nominal concentrations, probe effect, and array, we
  fitted a 3-way ANOVA model containing only main effects to the
  expression values from the spike-in transcripts. The estimated
  standard deviation of each effect is shown in the first three
  columns. The forth column shows the standard deviation of the error
  term. Finally, a measure of the amount of confounding between
  nominal concentration and the other two effects is included in
  columns five and six. We use the measure presented by Wu in
  Technometrics (1981), Volume 23, Number 1. An optimal design, such
  as a Latin Square, will have a measure of 0 for each imbalance. The
  more confounding the larger these values. Because Affymetrix using a
  latin square design, there is no imbalance.}

\nocite{*}

\bibliographystyle{plainnat}
\bibliography{spkDoc}

\end{document}

\name{spkAnova}
\alias{spkAnova}
\title{Anova Model for Microarray Spike-in Data}
\description{
  Computes the mean squared errors of a microarray spike-in design due
  to concentration, probe, array, and error. 
}
\usage{
spkAnova(object, model=expr~spike+probe+array)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{model}{the anova model}
}
\value{
  A vector of the mean squared errors from the anova model.

}
\author{Matthew N. McCall}
\examples{
data(affy)
spkAnova(affy)
}
\keyword{manip}

\name{spkBal}
\alias{spkBal}
\title{Quantify Microarry Spike-in Design Imbalance}
\description{
  Computes the imbalance of a microarray spike-in design due to probes
  and arrays.
}
\usage{
spkBal(object)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
}
\value{
  The probe and array imbalances.
}
\references{Wu, Chien-Fu, Iterative Construction of Nearly Balanced
  Assignments I: Categorical Covariates. Technometrics, Vol. 23,
  No. 1. (Feb, 1981), pp. 37-44.}
\author{Matthew N. McCall}
\examples{
data(affy)
spkBal(affy)
}
\keyword{manip}

\name{spkGNN}
\alias{spkGNN}
\title{Genes Needed to Detect N True Positives}
\description{
  Computes the number of genes one would need to consider to obtain a
  given number of truly positive genes if one considered genes in order
  of decreasing observed fold change.
}
\usage{
spkGNN(n, n.expr, n.unexpr, AccuracySlope, AccuracySD, nullfc)
}
\arguments{
  \item{n}{the desired number of true positives}
  \item{n.expr}{the actual number of truly expressed genes}
  \item{n.unexpr}{the actual number of truly unexpressed genes}
  \item{AccuracySlope}{the signal detect slope from the spkSlope function}
  \item{AccuracySD}{the standard deviation of the signal detect slope
    from the spkAccSD function}
  \item{nullfc}{a vector of null fold changes from the spkBox function}  
}
\value{
  This function returns the expected number of genes one would have to
  consider to obtain N true positives under the given conditions.
}
\author{Matthew N. McCall}
\examples{
data(affy)
spkSlopeOut <- spkSlope(affy)
spkBoxOut <- spkBox(affy, spkSlopeOut, fc=2)
AccuracySlope <- round(spkSlopeOut$slope[-1], digits=2)
AccuracySD <- round(spkAccSD(affy, spkSlopeOut), digits=2)
spkGNN(n=25, n.expr=100, n.unexpr=10000, AccuracySlope[2],
AccuracySD[2], spkBoxOut[[2]])
}
\keyword{manip}

\name{spkPairNS}
\alias{spkPairNS}
\title{Pairwise Comparisons for Non-Spike-in Genes}
\description{
  Compute log-ratios among non-spike-in genes. 
}
\usage{
spkPairNS(object, output="M")
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{output}{what to return; either "M" for log-ratios or "A" for
    average log expression.}
}
\value{
  A matrix containing either log-ratios (M) or average log expression
  (A). Rows are genes and columns are array pairings.
}
\author{Matthew N. McCall}
\examples{
data(affy)
affyPairNS <- spkPairNS(affy)
}
\keyword{manip}

\name{spkMA}
\alias{spkMA}
\title{MA Plots}
\description{
  Plots log-ratios (M) vs. average log expression (A) for a
  SpikeInExpressionSet object. 
}
\usage{
spkMA(object, spkSlopeOut, fc=2, tol=3, label=NULL, ylim=NULL,
outlier=1, reduce=TRUE, plot.legend=TRUE)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{spkSlopeOut}{the output from the spkSlope function}
  \item{fc}{the fold change of interest}
  \item{tol}{the precision (number of digits after decimal point) in fc}
  \item{label}{a character string to insert into the plot title}
  \item{ylim}{limits of y-axis}
  \item{outlier}{log fold change cut-off for outliers}
  \item{reduce}{if TRUE some points are removed from the background to
    speed plotting}
  \item{plot.legend}{if TRUE a legend is plotted}
}
\value{
  The MA plot is produced.
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
spkMA(affy, affySlope)
}
\keyword{hplot}

\name{summarySpkBox}
\alias{summarySpkBox}
\title{Summary of Fold Changes Calculated by spkBox}
\description{
  Prints a summary table of the data resulting from a call to spkBox.
}
\usage{
summarySpkBox(boxs)
}
\arguments{
  \item{boxs}{the output of a call to spkBox}
}
\value{
  A dataframe with 2 columns: the mean fold change and the median
  average distance of the fold changes.
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
affyBox <- spkBox(affy, affySlope)
plotSpkBox(affyBox) 
}
\keyword{manip}

\name{spkSlope}
\alias{spkSlope}
\title{Signal Detect Slope Plot}
\description{
  Plots observed expression vs. nominal concentration. The overall
  regression slope, as well as, regression slopes for low, medium, and
  high bins are computed and the regression lines plotted. 
}
\usage{
spkSlope(object, label = NULL, cuts=c(.6,.99), ...)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{label}{a character string to insert into the plot title}
  \item{cuts}{quantiles used to make the low, medium, and high bins}
  \item{...}{arguments passed to the plot function}
}
\details{
  The bins are created by computing the proportion of non-spike-in genes
  with expression values less than or equal to the average expression
  value at each nominal concentration. Using the default value of cuts,
  the high bin contains nominal concentrations with 99 percent or more
  of the non-spike-in expression 
  values lower than it. The medium bin contains nominal concentrations
  with between 60 and 99 percent of the non-spike-in expression values
  lower than it. The low bin contains nominal concentrations with less
  than 60 percent of the non-spike-in expression values lower than it.
}
\value{
  \item{avgExp}{average expression at each nominal concentration}
  \item{slopes}{the regression slopes - overall and for each bin}
  \item{breaks}{which spike-in levels fall in each bin}
  \item{brkpts}{the expression value of the cut points between bins}
  \item{prop}{the proportion of non-spike-in probes with expression less
  than the average expression at each nominal concentration}
}
\author{Matthew N. McCall}
\examples{
data(affy)
spkSlope(affy)
}
\keyword{hplot}
\keyword{manip}

\name{spkAccSD}
\alias{spkAccSD}
\title{Accuracy Standard Deviation}
\description{
  Estimates the standard deviation for spike-ins at the lowest possible
  fold change in each bin.
}
\usage{
spkAccSD(object, spkSlopeOut, tol=3)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{spkSlopeOut}{the output from the spkSlope function}
  \item{tol}{number of digits after decimal point}
}
\value{
  returns the median absolute deviation (MAD) for each bin. 
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
spkAccSD <- spkAccSD(affy, affySlope)
}
\keyword{manip}

\name{spkBox}
\alias{spkBox}
\title{Fold Change Calculations}
\description{
  A function to calculate the log-ratios stratified by which ALE groups
  yield the comparison. They are stratified by which bins are being
  compared to produce the given fold change.
}
\usage{
spkBox(object, spkSlopeOut, fc = 2, tol = 3, reduce=TRUE)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{spkSlopeOut}{the output of the spkSlope function}
  \item{fc}{the fold change of interest}
  \item{tol}{the precision (number of digits after decimal point) in fc}
  \item{reduce}{if TRUE the number of points plotted in the null bins is reduced}
}
\details{
  This function requires the output of spkSlope.
}
\value{
  A list with the log-ratios separated by ALE strata comparison.
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
spkBox(affy,affySlope)
}
\keyword{manip}

\name{spkVar}
\alias{spkVar}
\title{Spike-in Variance}
\description{
  Compute an estimate of the standard deviation in expression at each nominal concentration. 
}
\usage{
spkVar(object)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
}
\value{
  a matrix containing spike-in levels and corresponding MADs.
}
\author{Matthew N. McCall}
\examples{
data(affy)
spkVar(affy)
}
\keyword{manip}

\name{spkAll}
\alias{spkAll}
\title{Spike-in Functions Wrapper}
\description{
  A wrapper for the functions contained in the spkTools package, which
  calls each function.
}
\usage{
spkAll(object, label, model=expr~spike+probe+array, fc=NULL, tol=3,
xrngs=NULL, yrngs=NULL, cuts=c(.6,.99), potQuantile=.995,
gnn=c(25,100,10000), pch=".", output="eps")
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{label}{a character string to insert into the graphs and tables
    produced}
  \item{model}{model to be passed to spkAnova}
  \item{fc}{the fold change for which fold change plots will be produced}
  \item{tol}{the number of digits after the decimal point in fc}
  \item{xrngs}{ranges for the x-axis of each plot. d=density, s=slope,
    v=box, m=M vs A}
  \item{yrngs}{ranges for the y-axis of each plot. d=density, s=slope,
    v=box, m=M vs A}
  \item{cuts}{quantiles used to make the low, medium, and high bins}
  \item{potQuantile}{the desired quantile to compute the probability of
    being above}
  \item{gnn}{a vector of 3 numbers passed to spkGNN: the desired number
    of true positives, the number of truly expressed genes, and the
    number of truly unexpressed genes}
  \item{pch}{plotting point to be used in spkSlope}
  \item{output}{the format in which to save the plots produced. Options
    are "pdf" and "eps"}
}
\value{
  The full complement of plots and tables described in the vignette are
  created and saved in the current working directory.
}
\author{Matthew N. McCall}
\examples{
data(affy)
spkAll(affy, label="affy", fc=2)
}
\keyword{hplot}
\keyword{manip}

\name{spkPair}
\alias{spkPair}
\title{Pairwise Comparisons for Spike-in Genes}
\description{
  Compute log-ratios among spike-in genes. 
}
\usage{
spkPair(object)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
}
\value{
  An array containing either log-ratios (M), average log expression
  (A), and nominal concentrations (N1 & N2). Dimension one is genes,
  dimension two is array pairings, dimension three is M, A, N1, and N2. 
}
\author{Matthew N. McCall}
\examples{
data(affy)
affyPair <- spkPair(affy)
}
\keyword{manip}

\name{plotSpkBox}
\alias{plotSpkBox}
\title{Boxplots of Fold Changes Calculated by spkBox}
\description{
  Plots boxplots of the data resulting from a call to spkBox.
}
\usage{
plotSpkBox(boxs, fc=2, box.names=NULL, ...)
}
\arguments{
  \item{boxs}{the output of a call to spkBox}
  \item{fc}{expected fold change}
  \item{box.names}{names to be printed below each boxplot}
  \item{...}{parameters passed to boxplot}
}
\value{
  Boxplots for spike-in and non-spike-in comparisons stratified by
  ALE strata are produced.
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
affyBox <- spkBox(affy, affySlope)
plotSpkBox(affyBox) 
}
\keyword{hplot}

\name{spkPot}
\alias{spkPot}
\title{Probability of being in the Top}
\description{
  Compute the probability that a spike-in with a nominal fold change of
  2 appears in the the top 0.5\% (default) of log-ratios. 
}
\usage{
spkPot(object, spkSlopeOut, sig, SD, precisionQuantile)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{spkSlopeOut}{the output from the spkSlope function}
  \item{sig}{the signal detect slopes from a call to spkSlope}
  \item{SD}{the standard deviation from spkAccSD}
  \item{precisionQuantile}{the desired quantile to compute the
    probability of being above}
}
\value{
  A vector of probabilities for each ALE strata. 
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
affyAccSD <- spkAccSD(affy, affySlope)
spkPot(affy, affySlope, affySlope$slopes, affyAccSD, .995)
}
\keyword{manip}

\name{spkTools}
\alias{spkTools-package}
\alias{spkTools}
\docType{package}
\title{
Tools for Spike-in Data Analysis and Visualization
}
\description{
  A collection of functions to examine microarray datasets that
  include spike-ins. In particular, it allows one to explore the
  distribution of spike-ins within the range of possible expression
  values, the relationship between nominal concentration and expression,
  and the relationship between expected and observed fold change for
  different levels of comparison.
}
\details{
\tabular{ll}{
Package: \tab spkTools\cr
Type: \tab Package\cr
Version: \tab 0.0.1\cr
Date: \tab 2007-10-9\cr
License: \tab GPL version 2 or newer\cr
}

}
\author{
Matthew N. McCall

Maintainer: Matthew N. McCall <mmccall@jhsph.edu>
}
\keyword{ package }
\examples{
## The Three Plots
data(affy)
par(mfrow=c(2,2))
affySlope <- spkSlope(affy)
spkDensity(affy, affySlope)
spkBox(affy, affySlope)

## The Full Wrapper
data(affy)
spkAll(affy, label="Affymetrix", fc=2)
}

\name{affy}
\alias{affy}
\title{SpikeInExpressionSet of Affymetrix Spike-in Experiment Data}
\description{
This is a SpikeInExpressionSet object containing the data from the
Affymetrix  HGU133A Spike-in Experiment.
}
\usage{data(affy)}
\format{
It contains a matrix of expression values and a matrix of nominal
concentrations.
}
\source{
For more information see Irizarry, R.A., et al. NAR (2003)
\url{http://www.biostat.jhsph.edu/~ririzarr/papers/index.html}}

\keyword{datasets}

\name{SpikeInExpressionSet-class}
\docType{class}
\alias{class:SpikeInExpressionSet}
\alias{SpikeInExpressionSet-class}
\alias{SpikeInExpressionSet}
\alias{SpikeInExpressionSet-methods}
\alias{initialize,SpikeInExpressionSet-method}
\alias{spikeIn}
\alias{spkSplit}
\alias{spikeIn,SpikeInExpressionSet-method}
\alias{spikeIn<-,SpikeInExpressionSet,matrix-method}
\alias{spkSplit,SpikeInExpressionSet-method}
\title{
  Class to Contain and Describe High-Throughput Expression Level Assays
  with Spike-in Data}
\description{This is a class representation for spike-in expression
  data. \code{SpikeInExpressionSet} class is derived from
  \code{ExpressionSet}, and requires a matrix names \code{exprs}
  and a matrix named \code{spikeIn}.}
\section{Extends}{
  Extends class \code{ExpressionSet}.
  }
\section{Creating Objects}{

  \code{createSpikeInExpressionSet(exprs, spikeIn, ...)}

  \code{new("SpikeInExpressionSet",
    phenoData = new("AnnotatedDataFrame"),
    featureData = new("AnnotatedDataFrame"),
    experimentData = new("MIAME"),
    annotation = character(0),
    exprs = new("matrix"),
    spikeIn = new("matrix"))
  }  

  This creates a \code{SpikeInExpressionSet} with \code{assayData}
  implicitly created to contain \code{exprs} and
  \code{spikeIn}. Additional named matrix arguments with the same
  dimensions as \code{exprs} are added to \code{assayData}; the row
  and column names of these additional matrices should match those of
  \code{exprs} and \code{spikeIn}.

  \code{new("SpikeInExpressionSet",
    assayData = assayDataNew(exprs=new("matrix"),spikeIn=new("matrix")),  
    phenoData = new("AnnotatedDataFrame"),
    featureData = new("AnnotatedDataFrame"),
    experimentData = new("MIAME"),
    annotation = character(0),
  }

  This creates a \code{SpikeInExpressionSet} with \code{assayData}
  provided explicitly. In this form, the only required named argument is
  \code{assayData}.

}
    
\section{Slots}{
  Inherited from \code{ExpressionSet}:
  \describe{
    \item{\code{assayData}:}{Contains matrices with equal dimensions,
      and with column number equal to
      \code{nrow(phenoData)}. \code{assayData} must contain a matrix
      \code{exprs} and a matrix \code{spikeIn} with rows representing
      features and columns representing samples.}  
    \item{\code{phenoData}:}{See \code{eSet}}
    \item{\code{annotation}}{See \code{eSet}}
    \item{\code{featureData}}{See \code{eSet}}
    \item{\code{experimentData}:}{See \code{eSet}} 
  }
}

\section{Methods}{
  Class-specific methods:
  \describe{
    \item{\code{spikeIn(SpikeInExpressionSet)},
      \code{spikeIn(SpikeInExpressionSet)<-}}{Access and set elements
      named \code{spikeIn} in the \code{AssayData-class} slot.}
    \item{\code{spkSplit(SpikeInExpressionSet)}}{creates two SpikeInExpressionSet objects
      -- one with the spike-in probes and one with the non-spike-in
      probes.}
  }

  For derived methods (see \code{ExpressionSet}).
}

\seealso{
  \code{eSet-class}, \code{ExpressionSet-class}. 
} 

\examples{
# create an instance of SpikeInExpressionSet
new("SpikeInExpressionSet")

new("SpikeInExpressionSet", exprs=matrix(runif(1000), nrow=100), spikeIn=matrix(rep(1:10,100), nrow=100))

# class specific methods
data(affy)
affySpikes <- spikeIn(affy)
affySplit <- spkSplit(affy)
}

\keyword{classes}

\name{spkQuantile}
\alias{spkQuantile}
\title{Empirical Quantiles}
\description{
  An internal function called by spkSlope.
}
\usage{
spkQuantile(amt, avgE, ens, p)
}
\arguments{
  \item{amt}{a vector of nominal concentrations}
  \item{avgE}{the observed average expression corresponding to each
    nominal concentration}
  \item{ens}{the average expression across arrays of unexpressed genes}
  \item{p}{the quantiles to make the bins}
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
}
\keyword{manip}

\name{spkDensity}
\alias{spkDensity}
\title{Spike-in Density Plot}
\description{
  A density plot of the non-spike-in expression with a rug of the average expression at each spike-in level.
}
\usage{
spkDensity(object, spkSlopeOut, cuts=TRUE, label = NULL, ...)
}
\arguments{
  \item{object}{a SpikeInExpressionSet object}
  \item{spkSlopeOut}{the output from the spkSlope function}
  \item{cuts}{if TRUE vertical lines are drawn at the expression values
    separating low vs medium and medium vs high ALE strata}
  \item{label}{a character string to insert into the plot title}
  \item{...}{arguments passed to the plot function}
}
\details{
  This function requires the output of spkSlope.
}
\value{
  Density plot is produced.
}
\author{Matthew N. McCall}
\examples{
data(affy)
affySlope <- spkSlope(affy)
spkDensity(affy,affySlope)
}
\keyword{hplot}
